EDIT - feature request #6794

Improve term structure
07/09/2017 10:24 PM - Andreas Mller

Status: In Progress Start date:

Priority: Highest Due date:

Assignee: Andreas Muller % Done: 20%
Category: cdm Estimated time: 0:00 hour
Target version: CDM UML 5.43

Severity: normal

Description

Terms, terms structures and term collections need to be improved. Currently the only structures we have for terms are vocabularies
(ordered and unordered) and part-of and kind-of relations, where for each term only exactly one parent kind-of and one parent part-of
is allowed. Further more we do have FeatureTree and -Node as structure but only for features.

Generally what we need are

1. containers to group terms in collections, where each term might be part of many collections. how ever it is probably a good idea
to let a term belong to exactly one vocabulary.

2. structures to sort terms also in the above containers

3. structures to build term trees according to relationship types like part-of and kind-of (do we also need mixed trees? does it make
sense)

4. concept relationships between terms similar to taxon relationships with a relationship type based on set semantic (taxon
relationship types can be reused) or other semantic

To achieve this we could do the following

tree could also have dlfferent types included, e.g. Ieaves could be of different type than inner nodes (SDD)) so we could further
define termtype, eg. by being a set or defining different types for root, inner nodes and leaves, ...). Fhese-trees-can-also-be

. Common base class (or at Ieast mterface) TermCollection for vocabularles and TermTree to easy retrieve term coIIectlons
available to choose from. (1)

¢ New class TermRelationship that combines terms with a relationship and relationship type, similar to taxon relationships

A general problem is when should a term be referenced directly and when should we use a term node which is more or less a
wrapper around a term which is a term within a given collection. We need this for 2 and 3 somehow (even if for 2 we only have a
Set/List on TermCollection side on relational level we still need an M:N table as a term can be part of >1 such collections. If such a
table is needed we can also make it a class and attache some more attributes if required.

Term relationships could work without such a TermNode but then we have different structures to define relationships between terms,
one that uses term nodes as source and target of the relationships and one directly linking to terms, and if we keep the current
part-of and kind-of structure a 3rd one that linking directly from one term to another (source information - "who says this is a child" is
difficult to handle in this).

The simplest solution would be to only use TermNode for all relations. But this might be an overhead and also the handling in tree
structures is still different to undefined relationships as the tree structure has a term as source but a node as target while general
relationships have either both terms or nodes.

We could also consider nodes and relationships to be very similar, one handles a structure where each node can only be one time
part of a relationship within a given graph (however in theory it is possible that a term is source for many relationships in this graph
as terms may have multipe nodes), but these graphs are difficult to travers . Relationships require alternating traversion, from rel to
term to rel to term ...

But as they differ only in the target type we may have them with a common base class (but then TermRelationship can not inherit
from RelatioshipBase!) and store in the same table.

This makes it easy to query all terms belonging to a TermCollection as such a base class may have the attribute "termCollection”
similar to current "featureTree" in FeatureNode or "classification" in TaxonNode. This is a unidirectional relationship as it may be a
huge set. An exception might be terms belonging to a vocabulary as they directly point to their vocabulary (or can this be handled
differently? We could also use something like TermNode but this is overhead and not necessary

Another open question is if we want to allow any kind of structure within vocabularies. Probably it is better to not allow semantic
structure as this could lead to inconsistency. But purely to make terms easier to find it might be helpful to use hierarchies in large
vocabularies.

For consistency it might be helpful to also use a term tree for this, algorithms may only be implemented once then. However, the
model becomes more complex then with each term being represented by 2 objects instead of one. The first representing the term,
the second representing its positions in the vocabulary.

If we don't have a hierarchy structure within vocabularies, vocabularies with existing structure such as TDWG areas may require an

extra graph to represent the hierarchie, which is maybe not wanted. Hierarchy might become an optional attribute of a vocabulary,
with still each term directly linking to the vocabulary but optionally being part of a tree which the vocabulary holds the root for.

Questions

What about inapplicableif and onlyapplicableif, can this be used for other term types too, or do we still need special FeatureNodes or
simply don't use these fields for other term nodes.

Related issues:

Related to EDIT - feature request #8123: Make available features a DB preference Closed
Related to EDIT - task #7515: TypeDesignationStatusComparator to sort by voca... Resolved
Related to EDIT - feature request #8146: Adapt taxeditor Ul to structure and ... Closed
Related to EDIT - task #8166: Adapt dataportal to term structure changes Closed
Related to EDIT - bug #8251: LazylnitializationException (LIE) in featureTree... Closed
Related to EDIT - feature request #8241: Rename FeatureTreeEditor to TermTree... Closed
Related to EDIT - task #8405: Adapt cdm-vaadin to term structure changes Rejected
Related to EDIT - bug #8407: Fix "FeatureTest" New
Related to EDIT - task #8434: Change FeatureTree contollers to TermTree contr... Closed
Related to EDIT - feature request #8432: Improve "default" feature tree handling In Progress
Related to EDIT - feature request #8474: Make TermCollection.orderRelevant us... Closed
Related to EDIT - feature request #8476: Implement support for TermCollection... Closed
Related to EDIT - feature request #8477: Implement support for TermCollection... Closed
Related to EDIT - task #8466: Delete FeatureTree tables Closed
Related to EDIT - feature request #8647: Allow selecting named areas, ranks, ... New
Related to EDIT - feature request #6849: [DISCUSS] How to handle "kind of" te... In Progress
Related to EDIT - feature request #9409: [Decision] Which terms should be edi... New
Related to EDIT - feature request #9502: Implement subarea preference rule an... Resolved
Related to EDIT - bug #597: DefinedTerm problem solved In Progress
Related to EDIT - bug #9784: Update script for term order of ordered CDM terms New
Related to EDIT - bug #10198: Termremoval for OrderedTermVocabularies does no... Closed
Related to EDIT - task #10201: Make synonym type an enum Closed
Related to EDIT - feature request #10196: Hybrid structure-state terms Closed
Related to EDIT - bug #9987: Handle areas of different vocabularies in compar... New
Related to EDIT - bug #6343: TermVocabularies of OrderedTerms must be Ordered... In Progress
Related to EDIT - bug #8270: TermDTOs with an orderIndex are ordered in unord... New
Related to EDIT - task #6521: Check existing imports for handling new synonym... New
Related to EDIT - bug #10259: Terms of the default vocabularies should not be... New
Related to EDIT - bug #5556: Class Cast Exception in DefinedTermDaolmpl.getPa... Closed
Related to EDIT - feature request #10284: Allow term trees as filters for nam... Closed
Related to EDIT - feature request #9697: Remaining issues for reimplementatio... New
Related to EDIT - feature request #10353: Implement supplemental data editing... New
Related to EDIT - bug #10366: Adapt advanced search to use area tree New

Blocks EDIT - feature request #9305: Include additional TypeDesignationStatus... New
Copied from EDIT - feature request #10354: Show term data in term node detail... Closed

Associated revisions

Revision 15e58dad - 02/25/2019 08:49 PM - Andreas Muller

ref #6794 remove setRoot from FeatureTree

Revision ffe5e099 - 02/25/2019 08:49 PM - Andreas Miiller
ref #6794 add termType to FeatureTree and FeatureNode

Revision ba989ecb - 03/01/2019 10:26 AM - Patrick Plitzner
ref #6794 Fix termType comparison

Revision 2fe68f38 - 03/01/2019 04:17 PM - Patrick Plitzner

ref #6794 Adapt taxeditor to model changes (feature tree/node generics)

Revision c693e3b1 - 03/01/2019 04:17 PM - Patrick Plitzner
ref #6794 Add generics to FeatureNode and FeatureTree

Revision 86dbcOfc - 03/04/2019 08:49 AM - Patrick Plitzner
ref #6794 Add termType check to DefinedTermBase and TermVocabulary

Revision 64cf9d1d - 03/04/2019 01:21 PM - Andreas Miiller
ref #6794 fix early setting of termType during term loading

Revision f4e9f32a - 03/04/2019 01:50 PM - Andreas Miiller

ref #6794 fix termType settings in deleteTerms test and clean it up

Revision ee6886b5 - 03/04/2019 03:33 PM - Patrick Plitzner

ref #6794 deproxy term of feature node

Revision 30fc7ac4 - 03/05/2019 04:55 PM - Andreas Miiller

ref #6794 adapt FeatureTreeController property path to new FeatureNode structure

Revision 9db81ba4 - 04/15/2019 03:52 PM - Andreas Miiller

ref #6794 remove setRoot from FeatureTree

Revision 743a9157 - 04/15/2019 03:52 PM - Andreas Miiller
ref #6794 add termType to FeatureTree and FeatureNode

Revision f2ae523b - 04/15/2019 03:53 PM - Patrick Plitzner
ref #6794 Fix termType comparison

Revision f98fee95 - 04/15/2019 03:53 PM - Patrick Plitzner
ref #6794 Add generics to FeatureNode and FeatureTree

Revision 70709118 - 04/15/2019 03:53 PM - Patrick Plitzner
ref #6794 Add termType check to DefinedTermBase and TermVocabulary

Revision 78234aa8 - 04/15/2019 03:53 PM - Andreas Miiller
ref #6794 fix early setting of termType during term loading

Revision 7f1eb40e - 04/15/2019 03:53 PM - Andreas Miiller

ref #6794 fix termType settings in deleteTerms test and clean it up

Revision afc431d5 - 04/15/2019 03:53 PM - Patrick Plitzner

ref #6794 deproxy term of feature node

Revision 36d909f8 - 04/15/2019 03:53 PM - Andreas Miiller

ref #6794 adapt Feature TreeController property path to new FeatureNode structure

Revision 7c4fffcd - 07/19/2019 06:13 PM - Andreas Miiller
ref #6794 add TermRelationshipType

Revision cafaa5dd - 07/19/2019 06:13 PM - Andreas Miiller
ref #6794 add TermRelationshipType to test data

Revision 6645143a - 07/19/2019 06:13 PM - Andreas Miiller

ref #6794 adapt TermsDataSet-with_auditing_info in some packages after merge problem solved

Revision aa929473 - 07/19/2019 06:13 PM - Andreas Miiller
ref #6794 add term relation type to TermType and fix TermRelationType class

Revision 1¢313fd1 - 07/19/2019 06:13 PM - Andreas Miiller
ref #6794 add TermRelation and TermRelationBase

Revision 951¢829f - 07/19/2019 06:13 PM - Andreas Miiller

ref #6794 add TermRelation and rename FeatureNode -> TermTreeNode

Revision 3¢c06156¢ - 07/19/2019 06:13 PM - Andreas Miiller

ref #6794 rename TermVocabulary table to TermCollection and remaining rename FeatureNode -> TermTreeNode

Revision 4b1a00be - 07/19/2019 06:14 PM - Andreas Miuller

ref #6794 update script for name changes in FeatureNode and TermVocabulary

Revision b3340748 - 07/19/2019 06:14 PM - Andreas Miiller

ref #6794 change FeatureTree to TermTree

Revision 11df83d8 - 07/19/2019 06:14 PM - Andreas Miiller

ref #6794 add TermCollection and subclasses including TermTree

Revision 1¢c29785 - 07/19/2019 06:14 PM - Andreas Miiller

ref #6794 adjust hibernate configuration to new TermCollection and adjust test data

Revision c27ce9cc - 07/19/2019 06:14 PM - Andreas Miiller
ref #6794 update script for graph_id and root_id

Revision 4e5c4e73 - 07/19/2019 06:14 PM - Andreas Miiller

cleanup and ref #6794 rename TermTreeDaolmpl

Revision 502547d1 - 07/19/2019 06:14 PM - Andreas Miiller
ref #6794 fix FeatureNodeServicelmplTest

Revision 18dfe77e - 07/19/2019 06:14 PM - Andreas Miiller

ref #6794 move term relations down to TermCollection

Revision ec978653 - 07/19/2019 06:14 PM - Andreas Miiller

ref #6794 add TermRelation and rename FeatureNode -> TermTreeNode

Revision b72678a6 - 07/19/2019 06:14 PM - Andreas Miiller

ref #6794 change FeatureTree to TermTree

Revision def33852 - 07/19/2019 06:14 PM - Andreas Miiller

ref #6794 add TermCollection and subclasses including TermTree

Revision 9490720 - 07/19/2019 06:14 PM - Andreas Miiller

ref #6794 adapt TermCollection test data to boolean values in TermCollection

Revision 0d79¢535 - 07/19/2019 06:14 PM - Andreas Miiller

ref #6794 remove references to TermVocabulary.iterator()

Revision a2533432 - 07/19/2019 06:14 PM - Andreas Miiller
ref #6794 change schema version and add missing attributes to updateScript

Revision cf862eed - 07/19/2019 06:14 PM - Andreas Miiller

ref #6794 FeatureTreeMover first implementation (not yet ready)

Revision e793a739 - 07/19/2019 08:41 PM - Andreas Miiller

ref #6794 update some imports to model changes and add ITermTree

Revision 0d80c92f - 07/19/2019 08:42 PM - Andreas Miiller

ref #6794 add TermRelation and rename FeatureNode -> TermTreeNode

Revision 12740fe1 - 07/19/2019 08:42 PM - Andreas Miiller

ref #6794 change FeatureTree to TermTree

Revision 645aca37 - 07/19/2019 08:42 PM - Andreas Miiller

ref #6794 add TermCollection and subclasses including TermTree

Revision b996fc8c - 07/19/2019 08:42 PM - Andreas Miiller

cleanup and ref #6794 rename TermTreeDaolmpl

Revision 17ad77a7 - 07/19/2019 08:42 PM - Andreas Miiller

ref #6794 add TermRelation and rename FeatureNode -> TermTreeNode

Revision 3048fbc9 - 07/19/2019 08:45 PM - Andreas Miiller

ref #6794 add TermRelation and rename FeatureNode -> TermTreeNode

ref #6794 add TermRelation and TermRelationBase

Revision 0774bb03 - 07/19/2019 08:57 PM - Andreas Miiller

ref #6794 remove FeatureTree class

Revision ab5b84ab - 07/19/2019 09:03 PM - Andreas Miiller

ref #6794 remove FeatureTree from hibernate.cfg

Revision 40b05355 - 07/19/2019 09:13 PM - Andreas Miiller

ref #6794 remove duplicate TermRelationshipType in test/hibernate.cfg.xml

Revision 74d92b60 - 07/19/2019 10:24 PM - Andreas Miiller

ref #6794 minor adaptations of tests

Revision 3af337bb - 07/19/2019 11:28 PM - Andreas Miiller

ref #6794 finalize FeatureTreeMover (update treeindex)

Revision 76463827 - 07/22/2019 01:31 PM - Andreas Miiller

ref #6794 rename TermTreeNode -> TermNode

Revision 41061791 - 07/22/2019 01:35 PM - Andreas Miiller

ref #6794 rename TermTreeNode -> TermNode

Revision 77dad5ec - 07/22/2019 01:37 PM - Andreas Muller

ref #6794 rename getFeatureNode -> getTermNode in cdmlib-print

Revision 11bdf5c4 - 07/22/2019 01:38 PM - Andreas Miiller

ref #6794 rename TermTreeNode -> TermNode

Revision eb9880a0 - 07/22/2019 06:39 PM - Andreas Miiller

ref #6794 rename some parameters, methods and classes
Revision 2f72f4da - 07/22/2019 06:41 PM - Andreas Miiller

ref #6794 add TermNodeService and TermTreeService and make FeatureXXX services deprecated

Revision cbfdd05c - 07/22/2019 06:42 PM - Andreas Miiller
ref #6794 ignore FeatureTest

Revision f9e5¢38d - 07/24/2019 11:10 AM - Andreas Miiller

ref #6794 remove FeatureTree from some hibernate.cfgs again

Revision 85bfea3a - 07/24/2019 11:11 AM - Andreas Miiller

ref #6794 add TermTreeService and TermNodeService to httplnvokerServices

Revision 36fc6b9d - 07/24/2019 11:12 AM - Andreas Miiller

ref #6794 adapt jsonConfigurations.xml from FeatureTree/Node -> TermTree/Node

Revision cf4196d1 - 07/24/2019 11:13 AM - Andreas Miiller

ref #6794 some adaptations in Jaxb to FeatureTree -> TermTree

Revision 62779ba1 - 07/24/2019 11:14 AM - Andreas Miiller

ref #6794 javadoc update FeatureTree -> TermTree

Revision d10ceac8 - 07/24/2019 11:20 AM - Andreas Miiller
ref #6794 delete FeatureDao

Revision c5564cac - 07/24/2019 11:24 AM - Andreas Miiller

ref #6794 remove FeatureNodeService from BatchValidationUtil

Revision cb89f4f7 - 07/24/2019 08:10 PM - Andreas Miiller

ref #6794 adapt TaxEditor to new term structure (rename FeatureNode and FeatureTree)

Revision 160f1cbd - 07/25/2019 01:45 PM - Patrick Plitzner

ref #6794 Fix compile error

Revision 549e8cc5 - 07/25/2019 03:20 PM - Andreas Miiller

ref #6794 rename IFeatureTreeDao in ITermTreeDao

Revision 06de8afc - 07/25/2019 04:08 PM - Andreas Miiller

ref #6794 rename TermTree.Newlnstance and set old version to deprecated

(cherry picked from commit 08b758e2bfba66c82fbc5a636e455edccch9fal )

Revision 53c7a226 - 07/25/2019 04:20 PM - Andreas Miiller

ref #6794 rename other TermTree.NewInstance methods and set old version to deprecated

Revision 845a6a70 - 07/25/2019 05:42 PM - Patrick Plitzner

ref #6794 Replace FeatureTreeService with TermTreeService

Revision dd49afb6 - 07/29/2019 02:02 PM - Andreas Miiller
ref #6794 TermTreeNode-> TermNode in cdmlib-apps

Revision 1651209 - 08/17/2019 02:10 AM - Andreas Miiller
ref #6794 , ref #7099 adapt app-import, pesi, eflora to modelchanges

Revision de4de718 - 08/19/2019 12:33 PM - Andreas Miiller
ref #6794 , ref #7099 adapt E+M activator to terms package structure

Revision fe330183 - 08/28/2019 11:32 AM - Patrick Plitzner
ref #6794 Fix potential ClassCastException

Revision 9622040d - 08/28/2019 11:33 AM - Patrick Plitzner
ref #6794 Add progress monitor break point

Revision 06517e99 - 08/28/2019 12:14 PM - Patrick Plitzner
ref #6794 Fix endless loop in OWL export

Revision 94365b1b - 12/09/2022 03:41 AM - Andreas Miiller

ref #6794, ref #3327 remove equal methods from OrderedTermBase and -Vocabulary

Revision 6d7382df - 12/11/2022 01:30 AM - Andreas Miiller

ref #6794 reduce calls to isLower and isHigher in Rank class

Revision fc422f9b - 12/11/2022 01:34 AM - Andreas Miiller

ref #6794 reduce calls to isLower and isHigher in Rank class (cont.)

Revision 49520df1 - 12/11/2022 01:48 AM - Andreas Miiller

ref #6794 reduce calls to isLower and isHigher in Rank class in app-import

Revision d70fff5c - 12/11/2022 01:49 AM - Andreas Miiller

ref #6794 reduce calls to isLower and isHigher in Rank class in vaadin

Revision 993ef082 - 12/12/2022 04:48 PM - Andreas Miiller

ref #6794 Change OrderedTermBase to DefinedTermBase in CondensedDistributionComposer

Revision d60cb364 - 12/13/2022 11:42 AM - Andreas Miiller

ref #6794 helper for commit issue in OrderedTermBase removal

Revision 9c6f2a51 - 12/13/2022 11:44 AM - Andreas Miiller

ref #6794 remove OrderedTermBase in cdmlib

Revision ¢10067d5 - 12/13/2022 11:49 AM - Andreas Muller

ref #6794 remove OrderedTermBase from taxeditor

Revision cd05a561 - 12/13/2022 11:50 AM - Andreas Miuller

ref #6794 remove OrderedTermBase in app-import

Revision ¢1e0f30f - 12/13/2022 12:57 PM - Andreas Miiller
ref #6794 fix return type for orderindex

Revision da1315f1 - 12/14/2022 11:47 AM - Andreas Miiller

ref #6794 add deprecation and javadoc to OrderedTermVocabulary methods

History

#1 - 07/09/2017 10:57 PM - Andreas Miuller

- Description updated

#2 - 07/09/2017 11:00 PM - Andreas Miuller

- Description updated

#3 - 07/09/2017 11:02 PM - Andreas Miuller

- Description updated

#4 - 07/16/2017 10:33 AM - Andreas Miiller
- Target version changed from Unassigned CDM tickets to COM UML 5.0
#5 - 05/08/2018 02:55 PM - Andreas Miiller
- Priority changed from New to Highest

#6 - 05/14/2018 01:57 PM - Andreas Miiller
- Target version changed from CDM UML 5.0 to CDM UML 5.5

#7 - 02/22/2019 10:26 AM - Andreas Miiller

- Related to feature request #8123: Make available features a DB preference added

#8 - 02/22/2019 11:00 AM - Andreas Miiller
- Related to task #7515: TypeDesignationStatusComparator to sort by vocabulary first and then by term order added

#9 - 02/27/2019 08:37 AM - Patrick Plitzner
- Related to feature request #8146: Adapt taxeditor Ul to structure and property term type added

#11 - 03/01/2019 11:05 PM - Andreas Miiller

Current idea for a solution:
Collections:

e Common base class TermCollection(Base) for all Vocabularies and Graphs (Trees, Lists, Relationship Graphs)
o TermVocabulary: has a Set of Terms
o OrderedTermVocabulary: like TermVocabulary but with additional TermTree functionality, where all terms are at the same time terms within
the TermTree, allows to define a Vocabulary and its default feature tree at the same time
o TermTree: like current FeatureTree, for sets, lists and ordered and unordered trees
o TermGraph: Set of TermRelationships
e Attributes for trees: orderRelevant, allowsDuplicates, isFlat; for graphs: directed
¢ common method: getElements

Relationship:
e common base class TermRelationshipBase
o Relates to exactly 1 TermCollection
e TermNode (or TermTreeNode) for hierarchical and flat structures, relates a child term to the parent/root node, allows tree index
e TermRelationship for Graph structure, relates 2 terms (child, relatedToTerm)
Terms:
* remove-OrderedFermBase
¢ term belongs to single vocabulary
e term has multiple TermRelationshipBases
Others:
¢ Collections and TermNode do have count cache
Open issues:
root = collection? => difficult due to inheritance from IdentifiableEntity
how to call "child" in TermRelationshipBase (fromTerm, child, baseTerm)

L]
L]
¢ need to distinguish Term.fromRelationships and Term.toRelationships?
¢ interface for subtrees as they are also term collections

#12 - 03/06/2019 01:56 PM - Andreas Kohlbecker
- Related to task #8166: Adapt dataportal to term structure changes added

#13 - 04/30/2019 12:43 PM - Andreas Miiller

- Related to bug #8251: LazylnitializationException (LIE) in feature Tree webservice added

#14 - 04/30/2019 12:43 PM - Andreas Miiller

- Related to feature request #8241: Rename FeatureTreeEditor to TermTreeEditor added

#15 - 05/05/2019 11:17 AM - Andreas Miiller
- Target version changed from CDM UML 5.5 to CDM UML 5.15
#16 - 07/23/2019 01:20 PM - Andreas Miiller
- Status changed from New to In Progress

- % Done changed from 0 to 20

#17 - 07/23/2019 01:39 PM - Andreas Miiller
- Target version changed from CDM UML 5.15 to CDM UML 5.8

#18 - 07/25/2019 10:17 AM - Andreas Kohlbecker
- Related to task #8405: Adapt cdm-vaadin to term structure changes added

#19 - 07/25/2019 02:56 PM - Andreas Miiller
- Related to bug #8407: Fix "FeatureTest" added

#20 - 08/01/2019 08:28 AM - Andreas Kohlbecker

- Related to task #8434: Change FeatureTree contollers to TermTree controllers added

#21 - 08/01/2019 04:48 PM - Andreas Kohlbecker

- Related to feature request #8432: Improve "default" feature tree handling added

#22 - 08/01/2019 04:54 PM - Andreas Kohlbecker

- Description updated

#23 - 08/16/2019 02:49 PM - Andreas Miiller

- Related to feature request #8474: Make TermCollection.orderRelevant usable for TermTrees added

#24 - 08/16/2019 03:10 PM - Andreas Miiller

- Related to feature request #8476: Implement support for TermCollection.isFlat in TaxEditor added

#25 - 08/16/2019 03:38 PM - Andreas Miiller

- Related to feature request #8477: Implement support for TermCollection.allowDuplicates in TaxEditor added

#26 - 08/30/2019 07:32 PM - Andreas Miiller
- Target version changed from CDM UML 5.8 to COM UML 5.15

#27 - 11/01/2019 12:53 PM - Andreas Miiller
- Related to task #8466: Delete FeatureTree tables added

#28 - 11/04/2019 05:49 PM - Andreas Miiller

- Related to feature request #8647: Allow selecting named areas, ranks, presence-absence terms from term trees/collections added

#29 - 12/09/2019 01:14 PM - Andreas Miiller
- Related to feature request #6849: [DISCUSS] How to handle "kind of" term creation in TermEditor added

#30 - 06/23/2020 02:55 PM - Andreas Miiller
- Target version changed from CDM UML 5.15 to CDM UML 5.43

#31 - 11/16/2020 09:57 AM - Andreas Miiller

- Blocks feature request #9305: Include additional TypeDesignationStatus sort order (term tree) in CDM terms added

#32 - 01/21/2021 12:57 PM - Andreas Miiller

- Related to feature request #9409: [Decision] Which terms should be editable in term tree editor (and vocabulary editor) added

#33 - 03/11/2021 10:47 AM - Andreas Miiller

- Related to feature request #9502: Implement subarea preference rule and fallback areas for areas with complex hierarchy added

#36 - 09/17/2021 05:40 PM - Andreas Miiller
- Related to bug #597: DefinedTerm problem solved added

#37 - 10/15/2021 04:14 PM - Andreas Miiller
- Related to bug #9784: Update script for term order of ordered CDM terms added

#39 - 12/09/2022 02:30 AM - Andreas Miiller

- Tags set to terms

#41 - 12/09/2022 12:36 PM - Andreas Miiller

- Related to bug #10198: Termremoval for OrderedTermVocabularies does not work correctly due to incorrect compareTo and orderindex decrement
added

#44 - 12/13/2022 01:21 PM - Andreas Miiller

- Description updated

#45 - 12/13/2022 04:41 PM - Andreas Miiller
- Related to task #10201: Make synonym type an enum added

#46 - 12/14/2022 11:29 AM - Andreas Muller

- Related to feature request #10196: Hybrid structure-state terms added

#47 - 12/19/2022 11:03 AM - Andreas Miuiller

- Related to bug #9987: Handle areas of different vocabularies in comparator added

#48 - 01/04/2023 12:10 AM - Andreas Miiller
Issues with orderindex in existing database can be found by the following queries which search for records that have not direct predecessor (query1)
or have an equal orderindex (query2) :

SELECT dtb.DTYPE, dtb.id, dtb.titleCache, dtb.vocabulary_id, dtb.orderindex, voc.titleCache, dtb.*
FROM DefinedTermBase dtb INNER JOIN TermCollection voc ON voc.id = dtb.vocabulary_id
WHERE dtb.orderindex IS NOT NULL AND dtb.orderindex > 1

AND NOT EXISTS (SELECT * FROM DefinedTermBase dtb2 WHERE dtb2.orderindex = dtb.orderindex -1 AND dtb.
vocabulary_id = dtb2.vocabulary_id)

ORDER BY dtb.vocabulary_id, dtb.orderindex;

SELECT dtb.DTYPE, dtb.id, dtb.titleCache, dtb.vocabulary_id, dtb.orderindex, voc.titleCache, dtb.*
FROM DefinedTermBase dtb INNER JOIN TermCollection voc ON voc.id = dtb.vocabulary_id
WHERE dtb.orderindex IS NOT NULL
AND EXISTS (SELECT * FROM DefinedTermBase dtb2 WHERE dtb2.orderindex = dtb.orderindex AND dtb.vocabulary_id =
dtb2.vocabulary_id AND dtb2.id < dtb.id)
ORDER BY dtb.vocabulary_id, dtb.orderindex;

For query2 there are many issues e.g. in cyprus production (but cyprus seems to be an exception, other old DBs do not have so many issues).
Query2 is the more critical as in these cases the "correct" order can not be defined via SQL when transforming the data to the new data model.
Query1 is not critical as it keeps the existing order.

#50 - 01/05/2023 08:13 PM - Andreas Miiller

- Status changed from In Progress to Duplicate

#53 - 01/05/2023 08:16 PM - Andreas Miiller

- Status changed from Duplicate to In Progress

#56 - 01/06/2023 07:07 PM - Andreas Miiller

- Related to bug #6343: TermVocabularies of OrderedTerms must be OrderedVocabularies added

#57 - 01/06/2023 07:09 PM - Andreas Miiller

- Related to bug #8270: TermDTOs with an orderindex are ordered in unordered term vocabularies added

#58 - 02/22/2023 10:44 AM - Andreas Miiller

- Related to task #6521: Check existing imports for handling new synonym structure correctly added

#59 - 03/02/2023 12:10 PM - Andreas Miiller
- Related to bug #10259: Terms of the default vocabularies should not be moved or deleted added

#60 - 03/22/2023 10:32 AM - Andreas Miiller
- Related to bug #5556: Class Cast Exception in DefinedTermDaolmpl.getPartOf added

#61 - 03/22/2023 04:10 PM - Andreas Miiller

- Related to feature request #10284: Allow term trees as filters for named area dialogues added

#62 - 06/20/2023 12:38 PM - Andreas Miiller

- Related to feature request #9697: Remaining issues for reimplementation of termtree editors added

#63 - 06/20/2023 12:40 PM - Andreas Miiller

- Related to feature request #10353: Implement supplemental data editing for term trees added

#64 - 06/20/2023 12:47 PM - Andreas Miiller

- Copied from feature request #10354: Show term data in term node details view added

#65 - 06/29/2023 01:00 PM - Andreas Miiller
- Related to bug #10366: Adapt advanced search to use area tree added
